<?php

namespace ShineSoftware\Setefi\Controller\Hosted;

class Notify extends \ShineSoftware\Setefi\Controller\Main {

    public function execute() {
        $storeManager = $this->_objectManager->get('\Magento\Store\Model\StoreManagerInterface');
        $orderId = $this->getRequest()->getParam('merchantorderid');
        $responsecode = $this->getRequest()->getParam('responsecode');
        $errormessage = $this->getRequest()->getParam('result');
        $data = $this->getRequest()->getParams();
        $this->_logger->debug(__METHOD__ . " - " . json_encode($data));
        if ($responsecode == "000" && !empty($orderId)) {
            $order = $this->getOrder($orderId);
            $this->_createTransaction($order, $data);
            if (isset($data['result']) && $data['result'] == 'CAPTURED') {
                $this->_createInvoice($order);
            }
            $this->_sendOrderEmail($order);
            $url = $storeManager->getStore()->getUrl('checkout/onepage/success?paymentid=' . $data['paymentid'], ['_current' => true]);
        } elseif (!empty($orderId)) {
            if ($this->_cancelPayment($orderId, $errormessage)) {
                $url = $storeManager->getStore()->getUrl('checkout/', ['_current' => true]);
            } else {
                $url = $storeManager->getStore()->getUrl('checkout/onepage/failure/', ['_current' => true]);
            }
        } else {
            $url = $storeManager->getStore()->getUrl('checkout/onepage/failure/', ['_current' => true]);
        }
        die("$url");
    }

}

;
